/*
    SUPPL - a supplemental library for common useage
    Copyright (C) 1995,1996  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: FCOMPARE.C $
   $Locker:  $	$Name:  $	$State: Exp $

	int _fcompare(dseg, dofs, sseg, sofs)

	Compares the two normalized far pointers.

	Returns: == 0: both pointers are equal
			  > 0: 1st pointer > 2nd pointer
			  < 0: 1st pointer < 2nd pointer

	Target compilers: Micro-C v3.13, v3.14; Borland C v2, v3.1, v4.52

*/
#ifdef _MICROC_

#include <portable.h>

int _fcompare(unsigned const dseg, unsigned dofs
 , unsigned const sseg, unsigned sofs)
{	int seg, ofs;

	seg = dseg - sseg;
	ofs = dofs - sofs;

	if(seg < 0 || (seg == 0 && ofs < 0))
		return -1;
	return !!(seg | ofs);
}

#endif
