/*
    SUPPL - a supplemental library for common useage
    Copyright (C) 1995,1996  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: _GETDCWD.C $
   $Locker:  $	$Name:  $	$State: Exp $

	char *_getdwcd(int drive, char *buf, unsigned length)

	Retreive the fully-qualified path of: "<drive>:."
	The path _no_ trailing backslash, except the path is the root directory.

	If buf == NULL, a buffer of length bytes is malloc()'ed.

	Note: In any case, buf must be long enough to hold the complete path.
	length is not checked in any way!

	drive may be:
		0 == current drive
		1 == A:
		2 == B:
		 ... 

	Return:
		NULL: malloc() failed, non-existing drive, or drive invalid
		else: pointer to the path

	Target compilers: Micro-C only

*/

#ifdef _MICROC_
#include <portable.h>
#include "dfn.h"

#ifndef lint
static char const rcsid[] = 
	"$Id: _GETDCWD.C 1.1 1996/12/05 07:37:57 ska Exp $";
#endif

char *_getdcwd(int drive, char Xbuf[], unsigned length)
{
	char *buf;

	if((buf = Xbuf) || (buf = malloc(length))) {
		buf;						/* AX := buf */
		asm "mov si, ax";
		drive;						/* AX := drive */
		asm {
			mov dx, ax
			or ax, ax
			jz currDrive
			add al, 'A' - 1			;/* specified drive */
			jmp short putDrive
currDrive:
			mov ah, 19h
			int 21h
			add al, 'A'				;/* 0 == A: */
putDrive:
			mov Byte Ptr [si], al
			inc si
			mov Word Ptr [si], '\:'
			inc si
			inc si
			mov ah, 47h
			int 21h
		}
		if(Carry()) {				/* Get path failed */
			if(!Xbuf) free(buf);
			return NULL;
		}
	}
	return buf;
}
#endif	/* defined(_MICROC_) */
